C++ Utilities: CppUtilities::FlagEnumClassOperations Namespace Reference

C++ Utilities 5.34.1 Useful C++ classes and routines such as argument parser, IO and conversion utilities

Loading...
Searching...
No Matches
Functions
CppUtilities::FlagEnumClassOperations Namespace Reference

The FlagEnumClassOperations namespace contains operations for flag enums. More...

## Functions
template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>
constexpr FlagEnumClass | operator| (FlagEnumClass lhs, FlagEnumClass rhs)
template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>
constexpr bool | operator& (FlagEnumClass lhs, FlagEnumClass rhs)
template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>
constexpr bool | operator&& (FlagEnumClass lhs, FlagEnumClass rhs)
template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>
constexpr FlagEnumClass & | operator|= (FlagEnumClass &lhs, FlagEnumClass rhs)
template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>
constexpr FlagEnumClass & | operator+= (FlagEnumClass &lhs, FlagEnumClass rhs)
template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>
constexpr FlagEnumClass & | operator-= (FlagEnumClass &lhs, FlagEnumClass rhs)

## Detailed Description

The FlagEnumClassOperations namespace contains operations for flag enums.

## Function Documentation

## ◆ operator&()

template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>

bool CppUtilities::FlagEnumClassOperations::operator& | ( | FlagEnumClass | lhs,
|  | FlagEnumClass | rhs )
| constexpr

Definition at line 54 of file flagenumclass.h.

## ◆ operator&&()

template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>

bool CppUtilities::FlagEnumClassOperations::operator&& | ( | FlagEnumClass | lhs,
|  | FlagEnumClass | rhs )
| constexpr

Definition at line 62 of file flagenumclass.h.

## ◆ operator+=()

template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>

FlagEnumClass & CppUtilities::FlagEnumClassOperations::operator+= | ( | FlagEnumClass & | lhs,
|  | FlagEnumClass | rhs )
| constexpr

Definition at line 76 of file flagenumclass.h.

## ◆ operator-=()

template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>

FlagEnumClass & CppUtilities::FlagEnumClassOperations::operator-= | ( | FlagEnumClass & | lhs,
|  | FlagEnumClass | rhs )
| constexpr

Definition at line 83 of file flagenumclass.h.

## ◆ operator|()

template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>

FlagEnumClass CppUtilities::FlagEnumClassOperations::operator| | ( | FlagEnumClass | lhs,
|  | FlagEnumClass | rhs )
| constexpr

Definition at line 39 of file flagenumclass.h.

## ◆ operator|=()

template<typename FlagEnumClass, Traits::EnableIf< IsFlagEnumClass< FlagEnumClass > > * = nullptr>

FlagEnumClass & CppUtilities::FlagEnumClassOperations::operator|= | ( | FlagEnumClass & | lhs,
|  | FlagEnumClass | rhs )
| constexpr

Definition at line 69 of file flagenumclass.h.